
function LocalServerUtils() {}

LocalServerUtils.NS_RDONLY      = 0x01;
LocalServerUtils.NS_WRONLY      = 0x02;
LocalServerUtils.NS_CREATE_FILE = 0x08;
LocalServerUtils.NS_TRUNCATE    = 0x20;

// user -- read, write; group -- read; other -- read
LocalServerUtils.DEFAULT_FILE_PERMS = 00400 | 00200 | 00040 | 00004;

LocalServerUtils.TEMPORARY_FILE_URI = "annozillaTempBody.html";

LocalServerUtils.createTempURIFromString = function(str) {   

    try {
	// get the preferences directory
	var fileLocator = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);  
	var file = fileLocator.get("ProfD", Components.interfaces.nsIFile);
	
	// append servers filename
	file.append(LocalServerUtils.TEMPORARY_FILE_URI);        
	
    // initialize local file
    var localFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    
    localFile.initWithPath(file.path);
    
    // if it exists, delete it
    if (localFile.exists()) {
      localFile.remove(false);
    }
    
    // write flags
    var flags = LocalServerUtils.NS_WRONLY | LocalServerUtils.NS_CREATE_FILE | LocalServerUtils.NS_TRUNCATE;
    
    // get a file output stream
    var fileStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
    fileStream.init(localFile, flags, LocalServerUtils.DEFAULT_FILE_PERMS, 0);
    
    fileStream.write(str, str.length);
    fileStream.close();
    
    return localFile.path;
  }
  catch (e) {
    dump("Error writing out new file: " + e + "\n");
    return null;
  }
}
   
